Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netdev/if_mbed/if_mbed.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netdev/if_mbed/if_mbed.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netdev/if_mbed/if_mbed.c	(revision 429)
@@ -4,5 +4,5 @@
  *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
- *  Copyright (C) 2014 Cores Co., Ltd. Japan
+ *  Copyright (C) 2014-2019 Cores Co., Ltd. Japan
  * 
  *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
@@ -64,5 +64,5 @@
  * SUCH DAMAGE.
  * 
- * $FreeBSD: src/sys/i386/isa/if_mbed.c,v 1.148.2.4 1999/09/25 13:08:18 nyan Exp $
+ * $FreeBSD: src/sys/i386/isa/if_ed.c,v 1.148.2.4 1999/09/25 13:08:18 nyan Exp $
  */
 
@@ -200,5 +200,4 @@
 if_mbed_setrcr(T_IF_SOFTC *ic)
 {
-	T_MBED_SOFTC	*sc = ic->sc;
 }
 
@@ -318,6 +317,4 @@
 if_mbed_init(T_IF_SOFTC *ic)
 {
-	T_MBED_SOFTC *sc = ic->sc;
-
 	/* mbed_init 本体を呼び出す。*/
 	if_mbed_init_sub(ic);
@@ -347,5 +344,5 @@
 				}
 				if (link_mode_new != NEGO_FAIL) {
-					ethernetext_set_link_mode(link_mode_new);
+					ethernetext_set_link_mode(link_mode_new | PROMISCUOUS_MODE);
 					ETHER.EESIPR0 |= EDMAC_EESIPR_INI_TRANS;
 					ether_set_link_up(ether);
@@ -373,5 +370,4 @@
 if_mbed_read(T_IF_SOFTC *ic)
 {
-	T_MBED_SOFTC *sc = ic->sc;
 	T_NET_BUF *input = NULL;
 	uint_t align;
@@ -406,5 +402,4 @@
 if_mbed_start(T_IF_SOFTC *ic, T_NET_BUF *output)
 {
-	T_MBED_SOFTC *sc = ic->sc;
 	int32_t len, res, pos;
 
@@ -429,22 +424,27 @@
 if_mbed_eth_handler(void)
 {
-    uint32_t stat_edmac;
-    uint32_t stat_etherc;
-
-    /* Clear the interrupt request flag */
-    stat_edmac = (ETHER.EESR0 & ETHER.EESIPR0);       /* Targets are restricted to allowed interrupts */
-    ETHER.EESR0 = stat_edmac;
-    /* Reception-related */
-    if (stat_edmac & EDMAC_EESIPR_INI_RECV) {
-		isig_sem(if_softc.semid_rxb_ready);
-    }
+	uint32_t stat_edmac;
+	uint32_t stat_etherc;
+	ER ret;
+	
+	/* Clear the interrupt request flag */
+	stat_edmac = (ETHER.EESR0 & ETHER.EESIPR0);       /* Targets are restricted to allowed interrupts */
+	ETHER.EESR0 = stat_edmac;
+	/* Reception-related */
+	if (stat_edmac & EDMAC_EESIPR_INI_RECV) {
+		ret = isig_sem(if_softc.semid_rxb_ready);
+		if (ret != E_OK)
+			syslog(LOG_INFO, "semid_rxb_ready %d %x", ret, stat_edmac & EDMAC_EESIPR_INI_RECV);
+	}
 	if (stat_edmac & EDMAC_EESIPR_INI_TRANS) {
-		isig_sem(if_softc.semid_txb_ready);
-	}
-    /* E-MAC-related */
-    if (stat_edmac & EDMAC_EESIPR_INI_EtherC) {
-        /* Clear the interrupt request flag */
-        stat_etherc = (ETHER.ECSR0 & ETHER.ECSIPR0);  /* Targets are restricted to allowed interrupts */
-        ETHER.ECSR0  = stat_etherc;
-    }
-}
+		ret = isig_sem(if_softc.semid_txb_ready);
+		if (ret != E_OK)
+			syslog(LOG_INFO, "semid_txb_ready %d %x", ret, stat_edmac & EDMAC_EESIPR_INI_TRANS);
+	}
+	/* E-MAC-related */
+	if (stat_edmac & EDMAC_EESIPR_INI_EtherC) {
+		/* Clear the interrupt request flag */
+		stat_etherc = (ETHER.ECSR0 & ETHER.ECSIPR0);  /* Targets are restricted to allowed interrupts */
+		ETHER.ECSR0  = stat_etherc;
+	}
+}
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netdev/if_mbed/if_mbed.cfg
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netdev/if_mbed/if_mbed.cfg	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netdev/if_mbed/if_mbed.cfg	(revision 429)
@@ -4,5 +4,5 @@
  *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
- *  Copyright (C) 2014 Cores Co., Ltd. Japan
+ *  Copyright (C) 2014-2019 Cores Co., Ltd. Japan
  * 
  *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netdev/if_mbed/if_mbed.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netdev/if_mbed/if_mbed.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netdev/if_mbed/if_mbed.h	(revision 429)
@@ -4,5 +4,5 @@
  *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
- *  Copyright (C) 2014 Cores Co., Ltd. Japan
+ *  Copyright (C) 2014-2019 Cores Co., Ltd. Japan
  * 
  *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netdev/if_mbed/nic.cfg
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netdev/if_mbed/nic.cfg	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netdev/if_mbed/nic.cfg	(revision 429)
@@ -4,5 +4,5 @@
  *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
- *  Copyright (C) 2014 Cores Co., Ltd. Japan
+ *  Copyright (C) 2014-2019 Cores Co., Ltd. Japan
  * 
  *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netdev/if_mbed/nic_asp.cfg
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netdev/if_mbed/nic_asp.cfg	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netdev/if_mbed/nic_asp.cfg	(revision 429)
@@ -4,5 +4,5 @@
  *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
- *  Copyright (C) 2014 Cores Co., Ltd. Japan
+ *  Copyright (C) 2014-2019 Cores Co., Ltd. Japan
  * 
  *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netdev/if_mbed/nic_rename.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netdev/if_mbed/nic_rename.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netdev/if_mbed/nic_rename.h	(revision 429)
@@ -4,5 +4,5 @@
  *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
- *  Copyright (C) 2014 Cores Co., Ltd. Japan
+ *  Copyright (C) 2014-2019 Cores Co., Ltd. Japan
  * 
  *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netdev/if_mbed/tinet_nic_config.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netdev/if_mbed/tinet_nic_config.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netdev/if_mbed/tinet_nic_config.h	(revision 429)
@@ -4,5 +4,5 @@
  *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
- *  Copyright (C) 2014 Cores Co., Ltd. Japan
+ *  Copyright (C) 2014-2019 Cores Co., Ltd. Japan
  * 
  *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netdev/if_mbed/tinet_nic_defs.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netdev/if_mbed/tinet_nic_defs.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netdev/if_mbed/tinet_nic_defs.h	(revision 429)
@@ -4,5 +4,5 @@
  *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
- *  Copyright (C) 2014 Cores Co., Ltd. Japan
+ *  Copyright (C) 2014-2019 Cores Co., Ltd. Japan
  * 
  *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/icmp6.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/icmp6.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/icmp6.h	(revision 429)
@@ -291,6 +291,6 @@
 typedef struct t_router_advert_hdr {
 	T_ICMP6_HDR	hdr;
-	uint32_t	reachable;		/* [ms] 到達可能時間	*/
-	uint32_t	retransmit;		/* [ms] 近隣要請送信間隔	*/
+	uint32_t	reachable;		/* [us] 到達可能時間	*/
+	uint32_t	retransmit;		/* [us] 近隣要請送信間隔	*/
 	/* この後にオプションが続く */
 	} __attribute__((packed, aligned(2))) T_ROUTER_ADVERT_HDR;
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/in4_subr.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/in4_subr.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/in4_subr.c	(revision 429)
@@ -115,4 +115,9 @@
 #include <net/if_var.h>
 
+#ifdef SUPPORT_IGMP
+#include <netinet/udp_var.h>
+#include <netinet/ip_igmp.h>
+#endif /* of #ifdef SUPPORT_IGMP */
+
 #if defined(_IP4_CFG)
 
@@ -294,6 +299,9 @@
 
 	/* IP ããããè¨­å®ããã*/
-	if ((error = in4_set_header(*nbuf, len, dstaddr, srcaddr, proto, ttl)) != E_OK)
+	if ((error = in4_set_header(*nbuf, len, dstaddr, srcaddr, proto, ttl)) != E_OK) {
+		syscall(rel_net_buf(*nbuf));
+		*nbuf = NULL;
 		return error;
+		}
 
 	/* 4 ãªã¯ãããå¢çã¾ã§ããã£ã³ã°ã§åããã*/
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/in_itron.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/in_itron.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/in_itron.h	(revision 429)
@@ -62,5 +62,5 @@
 #define TFN_TCP_ALL		(0)
 
-#define TEV_TCP_RCV_OOB		(-0x201)
+#define TEV_TCP_RCV_OOB		(0x201)
 
 /* UDP 関係 */
@@ -75,5 +75,5 @@
 #define TFN_UDP_ALL		(0)
 
-#define TEV_UDP_RCV_DAT		(-0x221)
+#define TEV_UDP_RCV_DAT		(0x221)
 
 /* 一般 */
@@ -139,4 +139,7 @@
 extern ER	udp_cre_cep (ID cepid, T_UDP_CCEP *pk_ccep);
 
+extern ER	udp6_del_cep(ID cepid);
+extern ER	udp6_set_opt(ID cepid, int_t optname, void *optval, int_t optlen);
+extern ER	udp6_get_opt(ID cepid, int_t optname, void *optval, int_t optlen);
 extern ER	udp6_cre_cep (ID cepid, T_UDP6_CCEP *pk_ccep);
 
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/in_rename.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/in_rename.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/in_rename.h	(revision 429)
@@ -242,5 +242,6 @@
 #define arp_get_cache		_tinet_arp_get_cache
 
-#define ether_map_ipv4_multicast	_tinet_ether_map_ipv4_multicast
+#define ether_map_ipv4_multicast	\
+								_tinet_ether_map_ipv4_multicast
 
 /* netinet6/icmp6.c */
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/in_var.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/in_var.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/in_var.h	(revision 429)
@@ -141,5 +141,7 @@
 					inn_get_datagram(nbuf,len,maxlen,dst,src,next,hlim,nbatr,tmout)
 #define IN_IS_ADDR_MULTICAST(addr)	inn_is_addr_multicast(addr)
-#define IN_IS_NET_ADDR_MULTICAST(nbuf)	IN_IS_ADDR_MULTICAST(&GET_IP6_HDR(nbuf)->dst)
+#define IN_IS_NET_ADDR_MULTICAST(nbuf)	(GET_IP_VER(input)==IPV6_VERSION	\
+					?IN_IS_ADDR_MULTICAST(&GET_IP6_HDR(input)->dst)	\
+					:IN4_IS_ADDR_MULTICAST(ntohl(GET_IP4_HDR(input)->dst)))
 #define IN_ADDRWITHIFP(ifp,src,dst)	inn_addrwithifp(ifp,src,dst)
 #define IN_IS_ADDR_ANY(addr)		IN6_IS_ADDR_UNSPECIFIED(addr)
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip4_var.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip4_var.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip4_var.h	(revision 429)
@@ -106,4 +106,7 @@
 	uint8_t		idix;	/* mpfid ã®ã¤ã³ããã¯ã¹	*/
 	uint8_t		flags;	/* ãã©ã°		*/
+#ifdef IF_ETHER_MULTI_NIC
+	uint8_t		conn_pos;
+#endif
 #ifdef IF_ETHER_NIC_NET_BUF_ALIGN
 	uint8_t		nalign[IF_ETHER_NIC_NET_BUF_ALIGN];
@@ -124,4 +127,7 @@
 	uint8_t		idix;	/* mpfid ã®ã¤ã³ããã¯ã¹	*/
 	uint8_t		flags;	/* ãã©ã°		*/
+#ifdef IF_ETHER_MULTI_NIC
+	uint8_t		conn_pos;
+#endif
 #ifdef IF_ETHER_NIC_NET_BUF_ALIGN
 	uint8_t		nalign[IF_ETHER_NIC_NET_BUF_ALIGN];
@@ -178,4 +184,7 @@
 	uint8_t		idix;	/* mpfid ã®ã¤ã³ããã¯ã¹	*/
 	uint8_t		flags;	/* ãã©ã°		*/
+#ifdef IF_ETHER_MULTI_NIC
+	uint8_t		conn_pos;
+#endif
 #ifdef IF_ETHER_NIC_NET_BUF_ALIGN
 	uint8_t		nalign[IF_ETHER_NIC_NET_BUF_ALIGN];
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_igmp.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_igmp.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_igmp.c	(revision 429)
@@ -5,31 +5,39 @@
 *                   Tomakomai National College of Technology, JAPAN
 *
-*  ãLì ÒÍCÈºÌ (1)`(4) Ìð©CFree Software Foundation
-*  ÉæÁÄö\³êÄ¢é GNU General Public License Ì Version 2 ÉL
-*  q³êÄ¢éðð½·êÉÀèC{\tgEFAi{\tgEFA
-*  ðüÏµ½àÌðÜÞDÈº¯¶jðgpE¡»EüÏEÄzziÈºC
-*  pÆÄÔj·é±Æð³Åø·éD
-*  (1) {\tgEFAð\[XR[hÌ`Åp·éêÉÍCãLÌì
-*       \¦C±Ìpð¨æÑºLÌ³ÛØKèªC»ÌÜÜÌ`Å\[
-*      XR[hÉÜÜêÄ¢é±ÆD
-*  (2) {\tgEFAðCCu`®ÈÇC¼Ì\tgEFAJ­Ég
-*      pÅ«é`ÅÄzz·éêÉÍCÄzzÉº¤hL
-gip
-*      Ò}j
-AÈÇjÉCãLÌì \¦C±Ìpð¨æÑºL
-*      Ì³ÛØKèðfÚ·é±ÆD
-*  (3) {\tgEFAðC@íÉgÝÞÈÇC¼Ì\tgEFAJ­Ég
-*      pÅ«È¢`ÅÄzz·éêÉÍCÌðð½·±ÆD
-*    (a) ÄzzÉº¤hL
-gipÒ}j
-AÈÇjÉCãLÌ
-*        ì \¦C±Ìpð¨æÑºLÌ³ÛØKèðfÚ·é±ÆD
-*  (4) {\tgEFAÌpÉæè¼ÚIÜ½ÍÔÚIÉ¶¶é¢©Èé¹
-*      Q©çàCãLì Ò¨æÑTOPPERSvWFNgðÆÓ·é±ÆD
+*  ä¸è¨èä½æ¨©è
+ã¯ï¼ä»¥ä¸ã® (1)ï½(4) ã®æ¡ä»¶ãï¼Free Software Foundation
+*  ã«ãã£ã¦å
+¬è¡¨ããã¦ãã GNU General Public License ã® Version 2 ã«è¨
+*  è¿°ããã¦ããæ¡ä»¶ãæºããå ´åã«éãï¼æ¬ã½ããã¦ã§ã¢ï¼æ¬ã½ããã¦ã§ã¢
+*  ãæ¹å¤ãããã®ãå«ãï¼ä»¥ä¸åãï¼ãä½¿ç¨ã»è¤è£½ã»æ¹å¤ã»åé
+å¸ï¼ä»¥ä¸ï¼
+*  å©ç¨ã¨å¼ã¶ï¼ãããã¨ãç¡åã§è¨±è«¾ããï¼
+*  (1) æ¬ã½ããã¦ã§ã¢ãã½ã¼ã¹ã³ã¼ãã®å½¢ã§å©ç¨ããå ´åã«ã¯ï¼ä¸è¨ã®èä½
+*      æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãï¼ãã®ã¾ã¾ã®å½¢ã§ã½ã¼
+*      ã¹ã³ã¼ãä¸­ã«å«ã¾ãã¦ãããã¨ï¼
+*  (2) æ¬ã½ããã¦ã§ã¢ãï¼ã©ã¤ãã©ãªå½¢å¼ãªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
+*      ç¨ã§ããå½¢ã§åé
+å¸ããå ´åã«ã¯ï¼åé
+å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨
+*      è
+ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®èä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨
+*      ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
+*  (3) æ¬ã½ããã¦ã§ã¢ãï¼æ©å¨ã«çµã¿è¾¼ããªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
+*      ç¨ã§ããªãå½¢ã§åé
+å¸ããå ´åã«ã¯ï¼æ¬¡ã®æ¡ä»¶ãæºãããã¨ï¼
+*    (a) åé
+å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨è
+ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®è
+*        ä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
+*  (4) æ¬ã½ããã¦ã§ã¢ã®å©ç¨ã«ããç´æ¥çã¾ãã¯éæ¥çã«çãããããªãæ
+*      å®³ãããï¼ä¸è¨èä½æ¨©è
+ããã³TOPPERSãã­ã¸ã§ã¯ããå
+è²¬ãããã¨ï¼
 *
-*  {\tgEFAÍC³ÛØÅñ³êÄ¢éàÌÅ éDãLì Ò¨
-*  æÑTOPPERSvWFNgÍC{\tgEFAÉÖµÄC»ÌKpÂ\«à
-*  ÜßÄC¢©ÈéÛØàsíÈ¢DÜ½C{\tgEFAÌpÉæè¼
-*  ÚIÜ½ÍÔÚIÉ¶¶½¢©Èé¹QÉÖµÄàC»ÌÓCðíÈ¢D
+*  æ¬ã½ããã¦ã§ã¢ã¯ï¼ç¡ä¿è¨¼ã§æä¾ããã¦ãããã®ã§ããï¼ä¸è¨èä½æ¨©è
+ã
+*  ãã³TOPPERSãã­ã¸ã§ã¯ãã¯ï¼æ¬ã½ããã¦ã§ã¢ã«é¢ãã¦ï¼ãã®é©ç¨å¯è½æ§ã
+*  å«ãã¦ï¼ãããªãä¿è¨¼ãè¡ããªãï¼ã¾ãï¼æ¬ã½ããã¦ã§ã¢ã®å©ç¨ã«ããç´
+*  æ¥çã¾ãã¯éæ¥çã«çãããããªãæå®³ã«é¢ãã¦ãï¼ãã®è²¬ä»»ãè² ããªãï¼
 *
 *  @(#) $Id$
@@ -88,5 +96,5 @@
 
 static bool_t igmp_send_report_v2(T_IN4_ADDR dst);
-static uint16_t igmp_get_timer(T_IGMP_ENTRY *entry);
+static int16_t igmp_get_timer(T_IGMP_ENTRY *entry);
 
 ER igmp_set_loop(T_UDP_CEP *cep, uint8_t optval)
@@ -155,5 +163,4 @@
 	T_IGMP_ENTRY *entry = NULL;
 	int		i;
-	uint16_t	min;
 	T_IFNET	*ifp = IF_GET_IFNET();
 	ER ret = E_NOMEM;
@@ -168,5 +175,5 @@
 		entry = &igmp_groups[i];
 		if (entry->timer == -1) {
-			entry->timer = igmp_get_timer(entry);
+			entry->timer = 0;
 			entry->ip_addr = optval->imr_multiaddr;
 			ret = E_OK;
@@ -184,5 +191,4 @@
 	T_IGMP_ENTRY *entry = NULL;
 	int		i;
-	uint16_t	min;
 	ER ret = E_PAR;
 	T_IFNET	*ifp = IF_GET_IFNET();
@@ -223,5 +229,4 @@
 	T_NET_BUF	*input = *inputp;
 	T_IGMPV2_HDR	*igmph;
-	T_IN4_ADDR	addr;
 	uint_t		len, align;
 	T_IP4_HDR	*ip4h;
@@ -234,5 +239,5 @@
 	NET_COUNT_IGMP(net_count_igmp.in_packets, 1);
 
-	/* ICMP wb_Ì·³ð`FbN·éB*/
+	/* ICMP ãããã®é·ãããã§ãã¯ããã*/
 	if (input->len < IF_IP4_IGMP_HDR_SIZE) {
 		NET_COUNT_IGMP(net_count_igmp.in_err_packets, 1);
@@ -243,13 +248,13 @@
 	igmph = (T_IGMPV2_HDR *)(input->buf + *offp);
 
-	/* 4 INebg«EÌf[^· */
+	/* 4 ãªã¯ãããå¢çã®ãã¼ã¿é· */
 	len = input->len - *offp;
 	align = (len + 3) >> 2 << 2;
 
-	/* 4 INebg«EÜÅpfBOÅßéB*/
+	/* 4 ãªã¯ãããå¢çã¾ã§ããã£ã³ã°ã§åããã*/
 	if (align > len)
 		memset((uint8_t*)input->buf + input->len, 0, (size_t)(align - len));
 
-	/* `FbNTðvZ·éB*/
+	/* ãã§ãã¯ãµã ãè¨ç®ããã*/
 	if (in_cksum(igmph, align) != 0) {
 		NET_COUNT_IGMP(net_count_igmp.in_err_packets, 1);
@@ -257,5 +262,5 @@
 	}
 
-	/* bZ[WÌ^Éæèªò·éB*/
+	/* ã¡ãã»ã¼ã¸ã®åã«ããåå²ããã*/
 	switch (igmph->type) {
 	case IGMP_MEMBERSHIP_QUERY:
@@ -263,10 +268,10 @@
 		ret = false;
 
-		/* QÁÌO[vAhX©çÌNG[Ìê */
+		/* åå ä¸­ã®ã°ã«ã¼ãã¢ãã¬ã¹ããã®ã¯ã¨ãªã¼ã®å ´å */
 		syscall(wai_sem(SEM_IGMP_GROUP_LOCK));
 
 		for (i = 0; i < NUM_IGMP_ENTRY; i++) {
 			entry = &igmp_groups[i];
-			if ((entry->timer >= 0) && (entry->ip_addr == addr)) {
+			if ((entry->timer >= 0) && (entry->ip_addr == igmph->addr)) {
 				entry->resptime = igmph->time;
 				ret = true;
@@ -278,5 +283,5 @@
 
 		if (ret) {
-			/* o[Vbv|[gðM */
+			/* ã¡ã³ãã¼ã·ãããªãã¼ããéä¿¡ */
 			igmp_send_report_v2(ip4h->src);
 		}
@@ -293,5 +298,5 @@
 	T_IGMPV2_HDR	*igmph;
 	T_NET_BUF		*output;
-	uint_t			len, align;
+	uint_t			len = 0, align;
 
 	if (in4_get_datagram(&output, (uint_t)(IF_IP4_IGMP_HDR_SIZE + len), 0,
@@ -300,23 +305,23 @@
 		return false;
 
-	/* IGMP wb_ðÝè·éB*/
+	/* IGMP ããããè¨­å®ããã*/
 	igmph = GET_IGMPV2_HDR(output, IF_IP4_IGMP_HDR_OFFSET);
 	igmph->type = IGMP_MEMBERSHIP_REPORT_V2;
 	igmph->time = 0;
-	igmph->addr = dst;
-
-	/* 4 INebg«EÌf[^· */
+	igmph->addr = htonl(dst);
+
+	/* 4 ãªã¯ãããå¢çã®ãã¼ã¿é· */
 	align = (len + 3) >> 2 << 2;
 
-	/* 4 INebg«EÜÅpfBOÅßéB*/
+	/* 4 ãªã¯ãããå¢çã¾ã§ããã£ã³ã°ã§åããã*/
 	if (align > len)
-		memset((uint8_t*)GET_IGMP_SDU(output, IF_IP4_IGMP_HDR_OFFSET) + IP4_HDR_SIZE + len,
+		memset((uint8_t*)GET_IGMP_SDU(output, IF_IP4_IGMP_HDR_OFFSET) + len,
 			0, (size_t)(align - len));
 
-	/* `FbNTðvZ·éB*/
+	/* ãã§ãã¯ãµã ãè¨ç®ããã*/
 	igmph->sum = 0;
-	igmph->sum = in_cksum(igmph, (uint_t)(IF_IP4_IGMP_HDR_SIZE + align));
-
-	/* M·éB*/
+	igmph->sum = in_cksum(igmph, (uint_t)(IGMP_HDR_SIZE + align));
+
+	/* éä¿¡ããã*/
 	NET_COUNT_IGMP(net_count_igmp.out_octets,
 		output->len - GET_IF_IP4_HDR_SIZE(output));
@@ -330,5 +335,6 @@
 
 /*
-*  igmp_timer -- IGMP ¤Ê^C}[
+*  igmp_timer -- IGMP å
+±éã¿ã¤ãã¼
 */
 static void igmp_timer(void *ignore)
@@ -361,10 +367,9 @@
 
 /*
-*  igmp_init -- IGMP @\ðú»·éB
+*  igmp_init -- IGMP æ©è½ãåæåããã
 */
 
 void igmp_init(void)
 {
-	T_IGMP_ENTRY *entry = NULL;
 	int i;
 
@@ -397,12 +402,12 @@
 }
 
-uint16_t igmp_get_timer(T_IGMP_ENTRY *entry)
-{
-	uint16_t time = entry->resptime;
+int16_t igmp_get_timer(T_IGMP_ENTRY *entry)
+{
+	int16_t time = entry->resptime;
 
 	if (time == 0)
-		time = 10;
-
-	return net_rand() / (0x7fffffff / time);
+		time = 590;
+
+	return (int16_t)(net_rand() % time) + 10;
 }
 
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_igmp.cfg
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_igmp.cfg	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_igmp.cfg	(revision 429)
@@ -5,31 +5,39 @@
  *                   Tomakomai National College of Technology, JAPAN
  *
- *  ãLì ÒÍCÈºÌ (1)`(4) Ìð©CFree Software Foundation 
- *  ÉæÁÄö\³êÄ¢é GNU General Public License Ì Version 2 ÉL
- *  q³êÄ¢éðð½·êÉÀèC{\tgEFAi{\tgEFA
- *  ðüÏµ½àÌðÜÞDÈº¯¶jðgpE¡»EüÏEÄzziÈºC
- *  pÆÄÔj·é±Æð³Åø·éD
- *  (1) {\tgEFAð\[XR[hÌ`Åp·éêÉÍCãLÌì
- *       \¦C±Ìpð¨æÑºLÌ³ÛØKèªC»ÌÜÜÌ`Å\[
- *      XR[hÉÜÜêÄ¢é±ÆD
- *  (2) {\tgEFAðCCu`®ÈÇC¼Ì\tgEFAJ­Ég
- *      pÅ«é`ÅÄzz·éêÉÍCÄzzÉº¤hL
-gip
- *      Ò}j
-AÈÇjÉCãLÌì \¦C±Ìpð¨æÑºL
- *      Ì³ÛØKèðfÚ·é±ÆD
- *  (3) {\tgEFAðC@íÉgÝÞÈÇC¼Ì\tgEFAJ­Ég
- *      pÅ«È¢`ÅÄzz·éêÉÍCÌðð½·±ÆD
- *    (a) ÄzzÉº¤hL
-gipÒ}j
-AÈÇjÉCãLÌ
- *        ì \¦C±Ìpð¨æÑºLÌ³ÛØKèðfÚ·é±ÆD
- *  (4) {\tgEFAÌpÉæè¼ÚIÜ½ÍÔÚIÉ¶¶é¢©Èé¹
- *      Q©çàCãLì Ò¨æÑTOPPERSvWFNgðÆÓ·é±ÆD
+ *  ä¸è¨èä½æ¨©è
+ã¯ï¼ä»¥ä¸ã® (1)ï½(4) ã®æ¡ä»¶ãï¼Free Software Foundation 
+ *  ã«ãã£ã¦å
+¬è¡¨ããã¦ãã GNU General Public License ã® Version 2 ã«è¨
+ *  è¿°ããã¦ããæ¡ä»¶ãæºããå ´åã«éãï¼æ¬ã½ããã¦ã§ã¢ï¼æ¬ã½ããã¦ã§ã¢
+ *  ãæ¹å¤ãããã®ãå«ãï¼ä»¥ä¸åãï¼ãä½¿ç¨ã»è¤è£½ã»æ¹å¤ã»åé
+å¸ï¼ä»¥ä¸ï¼
+ *  å©ç¨ã¨å¼ã¶ï¼ãããã¨ãç¡åã§è¨±è«¾ããï¼
+ *  (1) æ¬ã½ããã¦ã§ã¢ãã½ã¼ã¹ã³ã¼ãã®å½¢ã§å©ç¨ããå ´åã«ã¯ï¼ä¸è¨ã®èä½
+ *      æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãï¼ãã®ã¾ã¾ã®å½¢ã§ã½ã¼
+ *      ã¹ã³ã¼ãä¸­ã«å«ã¾ãã¦ãããã¨ï¼
+ *  (2) æ¬ã½ããã¦ã§ã¢ãï¼ã©ã¤ãã©ãªå½¢å¼ãªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
+ *      ç¨ã§ããå½¢ã§åé
+å¸ããå ´åã«ã¯ï¼åé
+å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨
+ *      è
+ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®èä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨
+ *      ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
+ *  (3) æ¬ã½ããã¦ã§ã¢ãï¼æ©å¨ã«çµã¿è¾¼ããªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
+ *      ç¨ã§ããªãå½¢ã§åé
+å¸ããå ´åã«ã¯ï¼æ¬¡ã®æ¡ä»¶ãæºãããã¨ï¼
+ *    (a) åé
+å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨è
+ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®è
+ *        ä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
+ *  (4) æ¬ã½ããã¦ã§ã¢ã®å©ç¨ã«ããç´æ¥çã¾ãã¯éæ¥çã«çãããããªãæ
+ *      å®³ãããï¼ä¸è¨èä½æ¨©è
+ããã³TOPPERSãã­ã¸ã§ã¯ããå
+è²¬ãããã¨ï¼
  *
- *  {\tgEFAÍC³ÛØÅñ³êÄ¢éàÌÅ éDãLì Ò¨
- *  æÑTOPPERSvWFNgÍC{\tgEFAÉÖµÄC»ÌKpÂ\«à
- *  ÜßÄC¢©ÈéÛØàsíÈ¢DÜ½C{\tgEFAÌpÉæè¼
- *  ÚIÜ½ÍÔÚIÉ¶¶½¢©Èé¹QÉÖµÄàC»ÌÓCðíÈ¢D
+ *  æ¬ã½ããã¦ã§ã¢ã¯ï¼ç¡ä¿è¨¼ã§æä¾ããã¦ãããã®ã§ããï¼ä¸è¨èä½æ¨©è
+ã
+ *  ãã³TOPPERSãã­ã¸ã§ã¯ãã¯ï¼æ¬ã½ããã¦ã§ã¢ã«é¢ãã¦ï¼ãã®é©ç¨å¯è½æ§ã
+ *  å«ãã¦ï¼ãããªãä¿è¨¼ãè¡ããªãï¼ã¾ãï¼æ¬ã½ããã¦ã§ã¢ã®å©ç¨ã«ããç´
+ *  æ¥çã¾ãã¯éæ¥çã«çãããããªãæå®³ã«é¢ãã¦ãï¼ãã®è²¬ä»»ãè² ããªãï¼
  * 
  *  @(#) $Id$
@@ -37,11 +45,10 @@
 
 /*
- *  IGMP RtBM
-[Vt@C
+ *  IGMP ã³ã³ãã£ã®ã¥ã¬ã¼ã·ã§ã³ãã¡ã¤ã«
  */
 
 #if defined(_IP4_CFG) && defined(SUPPORT_IGMP)
 
-/* IGMP O[vXVpZ}tH */
+/* IGMP ã°ã«ã¼ãæ´æ°ç¨ã»ããã© */
 
 CRE_SEM(SEM_IGMP_GROUP_LOCK, { TA_TPRI, 1, 1 });
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_igmp.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_igmp.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_igmp.h	(revision 429)
@@ -5,31 +5,39 @@
  *                   Tomakomai National College of Technology, JAPAN
  *
- *  ãLì ÒÍCÈºÌ (1)`(4) Ìð©CFree Software Foundation
- *  ÉæÁÄö\³êÄ¢é GNU General Public License Ì Version 2 ÉL
- *  q³êÄ¢éðð½·êÉÀèC{\tgEFAi{\tgEFA
- *  ðüÏµ½àÌðÜÞDÈº¯¶jðgpE¡»EüÏEÄzziÈºC
- *  pÆÄÔj·é±Æð³Åø·éD
- *  (1) {\tgEFAð\[XR[hÌ`Åp·éêÉÍCãLÌì
- *       \¦C±Ìpð¨æÑºLÌ³ÛØKèªC»ÌÜÜÌ`Å\[
- *      XR[hÉÜÜêÄ¢é±ÆD
- *  (2) {\tgEFAðCCu`®ÈÇC¼Ì\tgEFAJ­Ég
- *      pÅ«é`ÅÄzz·éêÉÍCÄzzÉº¤hL
-gip
- *      Ò}j
-AÈÇjÉCãLÌì \¦C±Ìpð¨æÑºL
- *      Ì³ÛØKèðfÚ·é±ÆD
- *  (3) {\tgEFAðC@íÉgÝÞÈÇC¼Ì\tgEFAJ­Ég
- *      pÅ«È¢`ÅÄzz·éêÉÍCÌðð½·±ÆD
- *    (a) ÄzzÉº¤hL
-gipÒ}j
-AÈÇjÉCãLÌ
- *        ì \¦C±Ìpð¨æÑºLÌ³ÛØKèðfÚ·é±ÆD
- *  (4) {\tgEFAÌpÉæè¼ÚIÜ½ÍÔÚIÉ¶¶é¢©Èé¹
- *      Q©çàCãLì Ò¨æÑTOPPERSvWFNgðÆÓ·é±ÆD
+ *  ä¸è¨èä½æ¨©è
+ã¯ï¼ä»¥ä¸ã® (1)ï½(4) ã®æ¡ä»¶ãï¼Free Software Foundation
+ *  ã«ãã£ã¦å
+¬è¡¨ããã¦ãã GNU General Public License ã® Version 2 ã«è¨
+ *  è¿°ããã¦ããæ¡ä»¶ãæºããå ´åã«éãï¼æ¬ã½ããã¦ã§ã¢ï¼æ¬ã½ããã¦ã§ã¢
+ *  ãæ¹å¤ãããã®ãå«ãï¼ä»¥ä¸åãï¼ãä½¿ç¨ã»è¤è£½ã»æ¹å¤ã»åé
+å¸ï¼ä»¥ä¸ï¼
+ *  å©ç¨ã¨å¼ã¶ï¼ãããã¨ãç¡åã§è¨±è«¾ããï¼
+ *  (1) æ¬ã½ããã¦ã§ã¢ãã½ã¼ã¹ã³ã¼ãã®å½¢ã§å©ç¨ããå ´åã«ã¯ï¼ä¸è¨ã®èä½
+ *      æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãï¼ãã®ã¾ã¾ã®å½¢ã§ã½ã¼
+ *      ã¹ã³ã¼ãä¸­ã«å«ã¾ãã¦ãããã¨ï¼
+ *  (2) æ¬ã½ããã¦ã§ã¢ãï¼ã©ã¤ãã©ãªå½¢å¼ãªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
+ *      ç¨ã§ããå½¢ã§åé
+å¸ããå ´åã«ã¯ï¼åé
+å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨
+ *      è
+ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®èä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨
+ *      ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
+ *  (3) æ¬ã½ããã¦ã§ã¢ãï¼æ©å¨ã«çµã¿è¾¼ããªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
+ *      ç¨ã§ããªãå½¢ã§åé
+å¸ããå ´åã«ã¯ï¼æ¬¡ã®æ¡ä»¶ãæºãããã¨ï¼
+ *    (a) åé
+å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨è
+ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®è
+ *        ä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
+ *  (4) æ¬ã½ããã¦ã§ã¢ã®å©ç¨ã«ããç´æ¥çã¾ãã¯éæ¥çã«çãããããªãæ
+ *      å®³ãããï¼ä¸è¨èä½æ¨©è
+ããã³TOPPERSãã­ã¸ã§ã¯ããå
+è²¬ãããã¨ï¼
  *
- *  {\tgEFAÍC³ÛØÅñ³êÄ¢éàÌÅ éDãLì Ò¨
- *  æÑTOPPERSvWFNgÍC{\tgEFAÉÖµÄC»ÌKpÂ\«à
- *  ÜßÄC¢©ÈéÛØàsíÈ¢DÜ½C{\tgEFAÌpÉæè¼
- *  ÚIÜ½ÍÔÚIÉ¶¶½¢©Èé¹QÉÖµÄàC»ÌÓCðíÈ¢D
+ *  æ¬ã½ããã¦ã§ã¢ã¯ï¼ç¡ä¿è¨¼ã§æä¾ããã¦ãããã®ã§ããï¼ä¸è¨èä½æ¨©è
+ã
+ *  ãã³TOPPERSãã­ã¸ã§ã¯ãã¯ï¼æ¬ã½ããã¦ã§ã¢ã«é¢ãã¦ï¼ãã®é©ç¨å¯è½æ§ã
+ *  å«ãã¦ï¼ãããªãä¿è¨¼ãè¡ããªãï¼ã¾ãï¼æ¬ã½ããã¦ã§ã¢ã®å©ç¨ã«ããç´
+ *  æ¥çã¾ãã¯éæ¥çã«çãããããªãæå®³ã«é¢ãã¦ãï¼ãã®è²¬ä»»ãè² ããªãï¼
  *
  *  @(#) $Id$
@@ -39,77 +47,65 @@
 #define _IP_IGMP_H_
 
-#define NUM_IGMP_ENTRY				5	/* }`LXgO[vÌGg */
-
-#ifdef __CA850__
-#pragma pack(1)
-#elif __RX
-#pragma pack
-#elif _MSC_VER
-#pragma pack(push, 1)
-#endif
+#define NUM_IGMP_ENTRY				5	/* ãã«ãã­ã£ã¹ãã°ã«ã¼ãã®ã¨ã³ããªæ° */
 
  /*
-  *  IGMPv1 wb_Ìè`ARFC 1112
+  *  IGMPv1 ãããã®å®ç¾©ãRFC 1112
   */
 
 typedef struct t_igmpv1_hdr
 {
-	uint8_t		type;		/* bZ[WÌ^	*/
-	uint8_t		unused;		/* ¢gp			*/
-	uint16_t	sum;		/* `FbNT		*/
-	T_IN4_ADDR	addr;		/* O[vAhX */
-} T_IGMPV1_HDR;
+	uint8_t		type;		/* ã¡ãã»ã¼ã¸ã®å	*/
+	uint8_t		unused;		/* æªä½¿ç¨			*/
+	uint16_t	sum;		/* ãã§ãã¯ãµã 		*/
+	T_IN4_ADDR	addr;		/* ã°ã«ã¼ãã¢ãã¬ã¹ */
+}  __attribute__((packed)) T_IGMPV1_HDR;
 
 /*
-*  IGMPv2 wb_Ìè`ARFC 2236
+*  IGMPv2 ãããã®å®ç¾©ãRFC 2236
 */
 
 typedef struct t_igmpv2_hdr
 {
-	uint8_t		type;		/* bZ[WÌ^	*/
-	uint8_t		time;		/* ÅåÔ		*/
-	uint16_t	sum;		/* `FbNT		*/
-	T_IN4_ADDR	addr;		/* O[vAhX */
-} T_IGMPV2_HDR;
+	uint8_t		type;		/* ã¡ãã»ã¼ã¸ã®å	*/
+	uint8_t		time;		/* æå¤§å¿ç­æé		*/
+	uint16_t	sum;		/* ãã§ãã¯ãµã 		*/
+	T_IN4_ADDR	addr;		/* ã°ã«ã¼ãã¢ãã¬ã¹ */
+}  __attribute__((packed)) T_IGMPV2_HDR;
 
 typedef struct t_igmpv3_query_hdr
 {
-	uint8_t		type;		/* bZ[WÌ^	*/
-	uint8_t		time;		/* ÅåÔ		*/
-	uint16_t	sum;		/* `FbNT		*/
-	T_IN4_ADDR	grpaddr;	/* O[vAhX */
-	uint8_t		sqrv;		/* StOAQuerier Robustness Value */
+	uint8_t		type;		/* ã¡ãã»ã¼ã¸ã®å	*/
+	uint8_t		time;		/* æå¤§å¿ç­æé		*/
+	uint16_t	sum;		/* ãã§ãã¯ãµã 		*/
+	T_IN4_ADDR	grpaddr;	/* ã°ã«ã¼ãã¢ãã¬ã¹ */
+	uint8_t		sqrv;		/* Sãã©ã°ãQuerier Robustness Value */
 	uint8_t		qqic;		/* Qurier's Query Interval Code */
-	uint16_t	num;		/* M³Ì */
-	T_IN4_ADDR	sdraddr;	/* M³AhX */
-} T_IGMPV3Q_HDR;
+	uint16_t	num;		/* éä¿¡å
+ã®æ° */
+	T_IN4_ADDR	sdraddr;	/* éä¿¡å
+ã¢ãã¬ã¹ */
+}  __attribute__((packed)) T_IGMPV3Q_HDR;
 
 typedef struct t_igmp_group_record
 {
-	uint8_t		type;		/* bZ[WÌ^	*/
-	uint8_t		len;		/* âf[^·		*/
-	uint16_t	num;		/* M³Ì */
-	T_IN4_ADDR	grpaddr;	/* O[vAhX */
-	T_IN4_ADDR	sdraddr;	/* M³AhX	*/
-							/* âf[^		*/
-} T_IGMP_GROUP_RECORD;
+	uint8_t		type;		/* ã¡ãã»ã¼ã¸ã®å	*/
+	uint8_t		len;		/* è£å©ãã¼ã¿é·		*/
+	uint16_t	num;		/* éä¿¡å
+ã®æ° */
+	T_IN4_ADDR	grpaddr;	/* ã°ã«ã¼ãã¢ãã¬ã¹ */
+	T_IN4_ADDR	sdraddr;	/* éä¿¡å
+ã¢ãã¬ã¹	*/
+							/* è£å©ãã¼ã¿		*/
+}  __attribute__((packed)) T_IGMP_GROUP_RECORD;
 
 typedef struct t_igmpv3_report_hdr
 {
-	uint8_t		type;		/* bZ[WÌ^	*/
-	uint8_t		rsv1;		/* \ñ				*/
-	uint16_t	sum;		/* `FbNT		*/
-	uint16_t	rsv2;		/* \ñ				*/
-	uint16_t	num;		/* O[vR[hÌ */
-	T_IGMP_GROUP_RECORD record;	/* O[vR[h */
-} T_IGMPV3R_HDR;
-
-#ifdef __CA850__
-#pragma pack(8)
-#elif __RX
-#pragma unpack
-#elif _MSC_VER
-#pragma pack(pop)
-#endif
+	uint8_t		type;		/* ã¡ãã»ã¼ã¸ã®å	*/
+	uint8_t		rsv1;		/* äºç´				*/
+	uint16_t	sum;		/* ãã§ãã¯ãµã 		*/
+	uint16_t	rsv2;		/* äºç´				*/
+	uint16_t	num;		/* ã°ã«ã¼ãã¬ã³ã¼ãã®æ° */
+	T_IGMP_GROUP_RECORD record;	/* ã°ã«ã¼ãã¬ã³ã¼ã */
+}  __attribute__((packed)) T_IGMPV3R_HDR;
 
 #define IGMP_HDR_SIZE			(sizeof(T_IGMPV1_HDR))
@@ -125,15 +121,15 @@
 
 /*
-*  bZ[WÌ^
+*  ã¡ãã»ã¼ã¸ã®å
 */
 
-#define IGMP_MEMBERSHIP_QUERY		0x11	/* o[VbvNG[		*/
-#define IGMP_MEMBERSHIP_REPORT		0x12	/* o[Vbv|[g		*/
-#define IGMP_MEMBERSHIP_REPORT_V2	0x16	/* o[Vbv|[g		*/
-#define IGMP_LEAVE_GROUP			0x17	/* [uO[v				*/
-#define IGMP_MEMBERSHIP_REPORT_V3	0x22	/* o[Vbv|[g		*/
+#define IGMP_MEMBERSHIP_QUERY		0x11	/* ã¡ã³ãã¼ã·ããã¯ã¨ãªã¼		*/
+#define IGMP_MEMBERSHIP_REPORT		0x12	/* ã¡ã³ãã¼ã·ããã¬ãã¼ã		*/
+#define IGMP_MEMBERSHIP_REPORT_V2	0x16	/* ã¡ã³ãã¼ã·ããã¬ãã¼ã		*/
+#define IGMP_LEAVE_GROUP			0x17	/* ãªã¼ãã°ã«ã¼ã				*/
+#define IGMP_MEMBERSHIP_REPORT_V3	0x22	/* ã¡ã³ãã¼ã·ããã¬ãã¼ã		*/
 
 /*
-*  UDPÊM[_IvV
+*  UDPéä¿¡ç«¯ç¹ãªãã·ã§ã³
 */
 
@@ -168,12 +164,12 @@
 
 /*
- *  IGMP O[vGg
+ *  IGMP ã°ã«ã¼ãã¨ã³ããª
  */
 
 typedef struct igmp_entry
 {
-	uint16_t	timer;		/* MÜÅÌÔ[b]	*/
-	uint16_t	resptime;	/* ÅåÔ[b]	*/
-	T_IN4_ADDR	ip_addr;	/* IP AhX			*/
+	int16_t		timer;		/* éä¿¡ã¾ã§ã®æé[ç§]	*/
+	int16_t		resptime;	/* æå¤§å¿ç­æé[ç§]	*/
+	T_IN4_ADDR	ip_addr;	/* IP ã¢ãã¬ã¹			*/
 } T_IGMP_ENTRY;
 
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/tcp_input.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/tcp_input.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/tcp_input.c	(revision 429)
@@ -521,5 +521,19 @@
 
 				/* 相手のアドレスをコピーする。*/
+
+#if defined(_IP6_CFG) && defined(_IP4_CFG)
+
+				if (cep->flags & TCP_CEP_FLG_IPV4) {
+					(*cep->p_dstaddr4).ipaddr = ntohl(cep->dstaddr.ipaddr.s6_addr32[3]);
+					(*cep->p_dstaddr4).portno = cep->dstaddr.portno;
+					}
+				else
+					*cep->p_dstaddr = cep->dstaddr;
+
+#else	/* of #if defined(_IP6_CFG) && defined(_IP4_CFG) */
+
 				*cep->p_dstaddr = cep->dstaddr;
+
+#endif	/* of #if defined(_IP6_CFG) && defined(_IP4_CFG) */
 
 				if (IS_PTR_DEFINED(cep->callback)) {
@@ -847,5 +861,19 @@
 
 				/* 相手のアドレスをコピーする。*/
+
+#if defined(_IP6_CFG) && defined(_IP4_CFG)
+
+				if (cep->flags & TCP_CEP_FLG_IPV4) {
+					(*cep->p_dstaddr4).ipaddr = ntohl(cep->dstaddr.ipaddr.s6_addr32[3]);
+					(*cep->p_dstaddr4).portno = cep->dstaddr.portno;
+					}
+				else
+					*cep->p_dstaddr = cep->dstaddr;
+
+#else	/* of #if defined(_IP6_CFG) && defined(_IP4_CFG) */
+
 				*cep->p_dstaddr = cep->dstaddr;
+
+#endif	/* of #if defined(_IP6_CFG) && defined(_IP4_CFG) */
 
 				if (IS_PTR_DEFINED(cep->callback)) {
@@ -1363,4 +1391,8 @@
 	NTOHS(tcph->sport);
 	NTOHS(tcph->dport);
+
+	/* SDU 長 より 緊急ポインタが大きい場合 */
+	if (tcph->urp > tcph->sum)
+		goto drop;
 
 find_cep:
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/tcp_output.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/tcp_output.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/tcp_output.c	(revision 429)
@@ -369,6 +369,8 @@
 		tcph->flags |= TCP_FLG_URG;
 		}
-	else
+	else {
+		tcph->urp = 0;
 		cep->snd_up  = cep->snd_una;
+		}
 
 #endif	/* of #ifdef TCP_CFG_EXTENTIONS */
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/tcp_subr.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/tcp_subr.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/tcp_subr.c	(revision 429)
@@ -805,5 +805,5 @@
 
 T_TCP_CEP *
-tcp_drop (T_TCP_CEP *cep, ER errno)
+tcp_drop (T_TCP_CEP *cep, ER err)
 {
 #ifdef SUPPORT_MIB
@@ -815,5 +815,5 @@
 #endif	/* of #ifdef SUPPORT_MIB */
 
-	cep->error = errno;
+	cep->error = err;
 	if (TCP_FSM_HAVE_RCVD_SYN(cep->fsm_state)) {
 		cep->fsm_state = TCP_FSM_CLOSED;
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/tcp_timer.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/tcp_timer.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/tcp_timer.h	(revision 429)
@@ -86,8 +86,8 @@
  */
 
-#define TCP_SLOW_TMO		(ULONG_C(500)/NET_TIMER_CYCLE)	/* 500 [ms]	*/
-#define TCP_FAST_TMO		(ULONG_C(200)/NET_TIMER_CYCLE)	/* 200 [ms]	*/
+#define TCP_SLOW_TMO		(ULONG_C(500000)/NET_TIMER_CYCLE)	/* 500,000 [us]	*/
+#define TCP_FAST_TMO		(ULONG_C(200000)/NET_TIMER_CYCLE)	/* 200,000 [us]	*/
 
-#define TCP_SLOW_HZ		(ULONG_C(1000)/TCP_SLOW_TMO/NET_TIMER_CYCLE)	/* Hz	*/
+#define TCP_SLOW_HZ		(ULONG_C(1000000)/TCP_SLOW_TMO/NET_TIMER_CYCLE)	/* Hz	*/
 
 /* TCP タイマ値 */
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/tcp_usrreq.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/tcp_usrreq.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/tcp_usrreq.c	(revision 429)
@@ -897,5 +897,5 @@
 
 	/* tcp_rcv_buf の割当て長をリセットする。*/
-	cep->rcv_buf_len = 0;
+	cep->rcv_buf_len -= len;
 
 	/* 通信端点のロックを解除する。*/
